"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.styles = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _clsx = _interopRequireDefault(require("clsx"));

var _styles = require("@material-ui/core/styles");

var _useMediaQuery = _interopRequireDefault(require("@material-ui/core/useMediaQuery"));

var _Carousel = _interopRequireDefault(require("./Carousel"));

var _Image = _interopRequireDefault(require("../Image"));

var _Lightbox = _interopRequireDefault(require("./Lightbox"));

var _Media = _interopRequireDefault(require("./Media"));

var _MagnifyHint = _interopRequireDefault(require("./MagnifyHint"));

var _CarouselThumbnails = _interopRequireDefault(require("./CarouselThumbnails"));

var _get = _interopRequireDefault(require("lodash/get"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var styles = function styles(theme) {
  return {
    imageWrap: {
      height: '100%',
      width: '100%',
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'stretch',
      '& img': {
        maxHeight: '100%',
        maxWidth: '100%',
        objectFit: 'contain'
      }
    },
    thumbnail: {
      position: 'absolute',
      top: 0,
      left: 0,
      height: '100%',
      width: '100%'
    },
    lightboxCarousel: (0, _defineProperty2["default"])({
      flex: 1,
      justifyContent: 'center',
      overflow: 'hidden'
    }, theme.breakpoints.down('xs'), {
      margin: '0 !important'
    }),
    lightboxThumbs: {
      paddingBottom: theme.margins.container
    }
  };
};

exports.styles = styles;
var useStyles = (0, _styles.makeStyles)(styles, {
  name: 'RSFMediaCarousel'
});
/**
 * A carousel that displays images and videos for a product.  Specify
 * images and videos via the media prop, which should be of the form:
 *
 * ```js
 *  <MediaCarousel
 *    media={[
 *      { src: 'https://domain.com/path/to/image.jpg', alt: 'Red Shirt', type: 'image' },
 *      { src: 'https://domain.com/path/to/image.mpeg', alt: 'Demonstration', type: 'video' },
 *    ]}
 *    thumbnail={{
 *      src: 'https://domain.com/path/to/thumbnail.jpg', alt: 'thumbnail'
 *    }}
 *  />
 * ```
 *
 * To display a low-res thumbnail while high res images are loading, specify a `thumbnail` prop with `src` and `alt`
 *
 * Alternatively, you can provide a `product` prop as an object with `media` and `thumbnail` values that
 * adhere to the formats described above.
 *
 * ```js
 *  <MediaCarousel
 *    product={{
 *      media: [
 *        { src: 'https://domain.com/path/to/image.jpg', alt: 'Red Shirt', type: 'image' },
 *        { src: 'https://domain.com/path/to/image.mpeg', alt: 'Demonstration', type: 'video' },
 *      ],
 *      thumbnail: {
 *        src: 'https://domain.com/path/to/thumbnail.jpg', alt: 'thumbnail'
 *      }
 *    }}
 *  />
 * ```
 */

function MediaCarousel(props) {
  var thumbnails = props.thumbnails,
      thumbnail = props.thumbnail,
      thumbsClassName = props.thumbsClassName,
      magnifyHintClassName = props.magnifyHintClassName,
      imageProps = props.imageProps,
      lightboxProps = props.lightboxProps,
      classes = props.classes,
      media = props.media,
      magnifyProps = props.magnifyProps,
      id = props.id,
      CarouselComponent = props.CarouselComponent,
      MediaComponent = props.MediaComponent,
      CarouselThumbnailsComponent = props.CarouselThumbnailsComponent,
      others = (0, _objectWithoutProperties2["default"])(props, ["thumbnails", "thumbnail", "thumbsClassName", "magnifyHintClassName", "imageProps", "lightboxProps", "classes", "media", "magnifyProps", "id", "CarouselComponent", "MediaComponent", "CarouselThumbnailsComponent"]);

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      imagesLoaded = _useState2[0],
      setImagesLoaded = _useState2[1];

  var styles = useStyles({
    classes: classes
  });
  var ref = (0, _react.useRef)(null);

  var _useState3 = (0, _react.useState)(false),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      over = _useState4[0],
      setOver = _useState4[1];

  var _useState5 = (0, _react.useState)(0),
      _useState6 = (0, _slicedToArray2["default"])(_useState5, 2),
      selected = _useState6[0],
      setSelected = _useState6[1];

  var _useState7 = (0, _react.useState)(),
      _useState8 = (0, _slicedToArray2["default"])(_useState7, 2),
      lightboxActive = _useState8[0],
      setLightboxActive = _useState8[1];

  var theme = (0, _styles.useTheme)();
  var isSmall = (0, _useMediaQuery["default"])(theme.breakpoints.down('xs'));
  (0, _react.useEffect)(function () {
    // Reset selection index when media changes
    setSelected(0);
  }, [media]);
  var timeout = (0, _react.useRef)(null);
  var handleMouseEnter = (0, _react.useCallback)(function () {
    timeout.current = window.setTimeout(function () {
      setOver(true);
      timeout.current = null;
    }, 250);
  }, []);
  var handleMouseLeave = (0, _react.useCallback)(function () {
    setOver(false);

    if (timeout.current) {
      window.clearTimeout(timeout.current);
    }
  }, []);
  var onFullSizeImagesLoaded = (0, _react.useCallback)(function () {
    setImagesLoaded(true);
  }, []);
  var onClickCarousel = (0, _react.useCallback)(function (evt) {
    if (!evt.defaultPrevented) {
      setLightboxActive(true);
    }
  });
  (0, _react.useEffect)(function () {
    var firstImage = ref.current.querySelector('img');

    if (firstImage) {
      firstImage.addEventListener('load', onFullSizeImagesLoaded);
      return function () {
        return firstImage.removeEventListener('load', onFullSizeImagesLoaded);
      };
    }
  }, []);
  var belowAdornments = [];

  if (thumbnail && !imagesLoaded) {
    belowAdornments.push(_react["default"].createElement(_Image["default"], (0, _extends2["default"])({
      key: "thumbnail",
      className: styles.thumbnail,
      fill: true
    }, thumbnail)));
  }

  if (media && media.full && media.full.some(function (item) {
    return item.magnify;
  })) {
    belowAdornments.push(_react["default"].createElement(_MagnifyHint["default"], {
      key: "magnify-hint",
      over: over,
      disableExpand: lightboxActive,
      className: magnifyHintClassName
    }));
  }

  if (lightboxActive) {
    Object.assign(others, {
      autoplay: false,
      className: (0, _clsx["default"])(others.className, styles.lightboxCarousel),
      height: isSmall ? '100%' : null,
      slideStyle: _objectSpread({}, others.slideStyle || {}, {
        display: 'flex',
        justifyContent: 'center'
      })
    });
  }

  var handleLightboxClose = (0, _react.useCallback)(function () {
    setLightboxActive(false);
  }, []);

  var body = _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(CarouselComponent, (0, _extends2["default"])({
    id: id,
    ref: ref,
    belowAdornments: belowAdornments,
    classes: classes,
    onMouseEnter: handleMouseEnter,
    onMouseLeave: handleMouseLeave,
    onClick: onClickCarousel,
    selected: selected,
    setSelected: setSelected
  }, others), media && media.full && media.full.map(function (item, i) {
    return _react["default"].createElement(MediaComponent, (0, _extends2["default"])({
      key: i,
      onLoad: i === 0 ? onFullSizeImagesLoaded : null,
      magnifyProps: magnifyProps
    }, item, {
      magnify: lightboxActive && !isSmall ? false : item.magnify,
      imageProps: lightboxActive && !isSmall ? {
        fill: false,
        contain: true,
        src: (0, _get["default"])(item, 'magnify.src', item.src)
      } : item.imageProps
    }));
  })), thumbnails && media && _react["default"].createElement(CarouselThumbnailsComponent, {
    className: (0, _clsx["default"])(thumbsClassName, lightboxActive && styles.lightboxThumbs),
    bind: "".concat(id, ".index"),
    carouselId: id,
    selected: selected,
    setSelected: setSelected,
    thumbnails: media.thumbnails
  }));

  return _react["default"].createElement(_react["default"].Fragment, null, body, _react["default"].createElement(_Lightbox["default"], (0, _extends2["default"])({}, lightboxProps, {
    open: !!lightboxActive,
    onClose: handleLightboxClose
  }), body));
}

MediaCarousel.defaultProps = {
  lightboxProps: {},
  magnifyProps: {},
  thumbnails: true,
  MediaComponent: _Media["default"],
  CarouselComponent: _Carousel["default"],
  CarouselThumbnailsComponent: _CarouselThumbnails["default"]
};

var _default = _react["default"].memo(MediaCarousel);

exports["default"] = _default;
//# sourceMappingURL=MediaCarousel.js.map